libstdc++: std::unordered_multiset< _Value, _Hash, _Pred, _Alloc > Class Template Reference

libstdc++

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc > Class Template Reference
Containers » Unordered Associative

`#include <unordered_set>`

## Public Types
typedef _Hashtable::key_type | key_type
typedef _Hashtable::value_type | value_type
typedef _Hashtable::hasher | hasher
typedef _Hashtable::key_equal | key_equal
typedef _Hashtable::allocator_type | allocator_type
typedef _Hashtable::pointer | pointer
typedef _Hashtable::const_pointer | const_pointer
typedef _Hashtable::reference | reference
typedef _Hashtable::const_reference | const_reference
typedef _Hashtable::iterator | iterator
typedef _Hashtable::const_iterator | const_iterator
typedef _Hashtable::local_iterator | local_iterator
typedef _Hashtable::const_local_iterator | const_local_iterator
typedef _Hashtable::size_type | size_type
typedef _Hashtable::difference_type | difference_type

## Public Member Functions
| unordered_multiset ()=default
template<typename _InputIterator>
| unordered_multiset (_InputIterator __first, _InputIterator __last, const allocator_type &__a)
template<typename _InputIterator>
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type &__a)
template<typename _InputIterator>
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n, const hasher &__hf, const allocator_type &__a)
template<typename _InputIterator>
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (const allocator_type &__a)
| unordered_multiset (const unordered_multiset &)=default
| unordered_multiset (const unordered_multiset &__umset, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (size_type __n, const allocator_type &__a)
| unordered_multiset (size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multiset (size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (unordered_multiset &&)=default
| unordered_multiset (unordered_multiset &&__umset, const allocator_type &__a) noexcept(noexcept(_Hashtable(std::move(__umset._M_h), __a)))
size_type | bucket_count () const noexcept
size_type | bucket_size (size_type __n) const
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
template<typename... _Args>
iterator | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
bool | empty () const noexcept
template<__heterogeneous_hash_key< unordered_multiset > _Kt>
size_type | erase (_Kt &&__x)
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
allocator_type | get_allocator () const noexcept
hasher | hash_function () const
template<typename _InputIterator>
void | insert (_InputIterator __first, _InputIterator __last)
void | insert (initializer_list< value_type > __l)
key_equal | key_eq () const
float | load_factor () const noexcept
size_type | max_bucket_count () const noexcept
float | max_load_factor () const noexcept
void | max_load_factor (float __z)
size_type | max_size () const noexcept
unordered_multiset & | operator= (const unordered_multiset &)=default
unordered_multiset & | operator= (initializer_list< value_type > __l)
unordered_multiset & | operator= (unordered_multiset &&)=default
void | rehash (size_type __n)
void | reserve (size_type __n)
size_type | size () const noexcept
void | swap (unordered_multiset &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
iterator | begin () noexcept
const_iterator | begin () const noexcept
iterator | end () noexcept
const_iterator | end () const noexcept
iterator | insert (const value_type &__x)
iterator | insert (value_type &&__x)
iterator | insert (const_iterator __hint, const value_type &__x)
iterator | insert (const_iterator __hint, value_type &&__x)
iterator | erase (const_iterator __position)
iterator | erase (iterator __position)
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
size_type | count (const key_type &__x) const
bool | contains (const key_type &__x) const
template<typename _Kt>
auto | contains (const _Kt &__x) const -> decltype(_M_h._M_find_tr(__x), void(), true)
std::pair< iterator, iterator > | equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
size_type | bucket (const key_type &__key) const
template<__heterogeneous_hash_key< unordered_multiset > _Kt>
size_type | bucket (const _Kt &__key) const
local_iterator | begin (size_type __n)
const_local_iterator | begin (size_type __n) const
const_local_iterator | cbegin (size_type __n) const
local_iterator | end (size_type __n)
const_local_iterator | end (size_type __n) const
const_local_iterator | cend (size_type __n) const

## Friends
template<typename _Value1, typename _Hash1, typename _Pred1, typename _Alloc1>
bool | operator== (const unordered_multiset< _Value1, _Hash1, _Pred1, _Alloc1 > &, const unordered_multiset< _Value1, _Hash1, _Pred1, _Alloc1 > &)

## Detailed Description

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
class std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >

A standard container composed of equivalent keys (possibly containing multiple of each key value) in which the elements' keys are the elements themselves.

Since
  C++11

Template Parameters

  _Value | Type of key objects.
  _Hash | Hashing function object type, defaults to hash<_Value>.
  _Pred | Predicate function object type, defaults to equal_to<_Value>.
  _Alloc | Allocator type, defaults to allocator<_Key>.

Meets the requirements of a container, and unordered associative container

Base is _Hashtable, dispatched at compile time via template alias __umset_hashtable.

Definition at line 1151 of file unordered_set.h.

## Member Typedef Documentation

## ◆ allocator_type

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::allocator_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::allocator_type

Public typedefs.

Definition at line 1164 of file unordered_set.h.

## ◆ const_iterator

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_iterator

Iterator-related typedefs.

Definition at line 1174 of file unordered_set.h.

## ◆ const_local_iterator

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_local_iterator

Iterator-related typedefs.

Definition at line 1176 of file unordered_set.h.

## ◆ const_pointer

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_pointer std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_pointer

Iterator-related typedefs.

Definition at line 1170 of file unordered_set.h.

## ◆ const_reference

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_reference std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_reference

Iterator-related typedefs.

Definition at line 1172 of file unordered_set.h.

## ◆ difference_type

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::difference_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::difference_type

Iterator-related typedefs.

Definition at line 1178 of file unordered_set.h.

## ◆ hasher

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::hasher std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::hasher

Public typedefs.

Definition at line 1162 of file unordered_set.h.

## ◆ iterator

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::iterator

Iterator-related typedefs.

Definition at line 1173 of file unordered_set.h.

## ◆ key_equal

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::key_equal std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_equal

Public typedefs.

Definition at line 1163 of file unordered_set.h.

## ◆ key_type

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::key_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_type

Public typedefs.

Definition at line 1160 of file unordered_set.h.

## ◆ local_iterator

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::local_iterator

Iterator-related typedefs.

Definition at line 1175 of file unordered_set.h.

## ◆ pointer

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::pointer std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 1169 of file unordered_set.h.

## ◆ reference

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::reference std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::reference

Iterator-related typedefs.

Definition at line 1171 of file unordered_set.h.

## ◆ size_type

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::size_type

Iterator-related typedefs.

Definition at line 1177 of file unordered_set.h.

## ◆ value_type

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::value_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::value_type

Public typedefs.

Definition at line 1161 of file unordered_set.h.

## Constructor & Destructor Documentation

## ◆ unordered_multiset() [1/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( |  | ) |
| default

Default constructor.

## ◆ unordered_multiset() [2/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | size_type | __n,
|  | const hasher & | __hf = hasher(),
|  | const key_equal & | __eql = key_equal(),
|  | const allocator_type & | __a = allocator_type() )
| inlineexplicit

Default constructor creates no elements.

Parameters

  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Definition at line 1198 of file unordered_set.h.

## ◆ unordered_multiset() [3/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n = 0,
|  | const hasher & | __hf = hasher(),
|  | const key_equal & | __eql = key_equal(),
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds an unordered_multiset from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_multiset consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 1219 of file unordered_set.h.

## ◆ unordered_multiset() [4/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | const unordered_multiset< _Value, _Hash, _Pred, _Alloc > & |  | ) |
| default

Copy constructor.

## ◆ unordered_multiset() [5/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > && |  | ) |
| default

Move constructor.

## ◆ unordered_multiset() [6/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | size_type | __n = 0,
|  | const hasher & | __hf = hasher(),
|  | const key_equal & | __eql = key_equal(),
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds an unordered_multiset from an initializer_list.

Parameters

  __l | An initializer_list.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_multiset consisting of copies of the elements in the list. This is linear in N (where N is __l.size()).

Definition at line 1244 of file unordered_set.h.

## ◆ unordered_multiset() [7/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | const allocator_type & | __a | ) |
| inlineexplicit

Creates an unordered_multiset with no elements.

Parameters

  __a | An allocator object.

Definition at line 1265 of file unordered_set.h.

## ◆ unordered_multiset() [8/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | const unordered_multiset< _Value, _Hash, _Pred, _Alloc > & | __umset,
|  | const allocator_type & | __a )
| inline

Definition at line 1274 of file unordered_set.h.

## ◆ unordered_multiset() [9/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > && | __umset,
|  | const allocator_type & | __a )
| inlinenoexcept

Definition at line 1284 of file unordered_set.h.

## ◆ unordered_multiset() [10/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | size_type | __n,
|  | const allocator_type & | __a )
| inline

Definition at line 1290 of file unordered_set.h.

## ◆ unordered_multiset() [11/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a )
| inline

Definition at line 1294 of file unordered_set.h.

## ◆ unordered_multiset() [12/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a )
| inline

Definition at line 1302 of file unordered_set.h.

## ◆ unordered_multiset() [13/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const allocator_type & | __a )
| inline

Definition at line 1308 of file unordered_set.h.

## ◆ unordered_multiset() [14/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a )
| inline

Definition at line 1315 of file unordered_set.h.

## ◆ unordered_multiset() [15/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a )
| inline

Definition at line 1323 of file unordered_set.h.

## ◆ unordered_multiset() [16/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const allocator_type & | __a )
| inline

Definition at line 1328 of file unordered_set.h.

## ◆ unordered_multiset() [17/17]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a )
| inline

Definition at line 1334 of file unordered_set.h.

## Member Function Documentation

## ◆ begin() [1/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multiset.

Definition at line 1437 of file unordered_set.h.

## ◆ begin() [2/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( |  | ) |
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multiset.

Definition at line 1433 of file unordered_set.h.

## ◆ begin() [3/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) |
| inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1936 of file unordered_set.h.

## ◆ begin() [4/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) | const
| inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1940 of file unordered_set.h.

## ◆ bucket() [1/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<__heterogeneous_hash_key< unordered_multiset > _Kt>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::bucket | ( | const _Kt & | __key | ) | const
| inline

Definition at line 1923 of file unordered_set.h.

## ◆ bucket() [2/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::bucket | ( | const key_type & | __key | ) | const
| inline

Definition at line 1917 of file unordered_set.h.

## ◆ bucket_count()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::bucket_count | ( |  | ) | const
| inlinenoexcept

Returns the number of buckets of the unordered_multiset.

Definition at line 1893 of file unordered_set.h.

## ◆ bucket_size()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::bucket_size | ( | size_type | __n | ) | const
| inline

Definition at line 1907 of file unordered_set.h.

## ◆ cbegin() [1/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multiset.

Definition at line 1460 of file unordered_set.h.

## ◆ cbegin() [2/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cbegin | ( | size_type | __n | ) | const
| inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1944 of file unordered_set.h.

## ◆ cend() [1/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multiset.

Definition at line 1468 of file unordered_set.h.

## ◆ cend() [2/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cend | ( | size_type | __n | ) | const
| inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1964 of file unordered_set.h.

## ◆ clear()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::clear | ( |  | ) |
| inlinenoexcept

Erases all elements in an unordered_multiset.

Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1709 of file unordered_set.h.

## ◆ contains() [1/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _Kt>

auto std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::contains | ( | const _Kt & | __x | ) | const -> decltype(_M_h._M_find_tr(__x), void(), true)
| inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 1851 of file unordered_set.h.

## ◆ contains() [2/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

bool std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::contains | ( | const key_type & | __x | ) | const
| inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 1846 of file unordered_set.h.

## ◆ count()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::count | ( | const key_type & | __x | ) | const
| inline

Finds the number of elements.

Parameters

  __x | Element to located.

Returns
  Number of elements with specified key.

Definition at line 1827 of file unordered_set.h.

## ◆ emplace()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename... _Args>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::emplace | ( | _Args &&... | __args | ) |
| inline

Builds and insert an element into the unordered_multiset.

Parameters

  __args | Arguments used to generate an element.

Returns
  An iterator that points to the inserted element.

Insertion requires amortized constant time.

Definition at line 1482 of file unordered_set.h.

## ◆ emplace_hint()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename... _Args>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args )
| inline

Inserts an element into the unordered_multiset.

Parameters

  __pos | An iterator that serves as a hint as to where the element should be inserted.
  __args | Arguments used to generate the element to be inserted.

Returns
  An iterator that points to the inserted element.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant time.

Definition at line 1504 of file unordered_set.h.

## ◆ empty()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

bool std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardnoexcept

Returns true if the unordered_multiset is empty.

Definition at line 1412 of file unordered_set.h.

## ◆ end() [1/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multiset.

Definition at line 1451 of file unordered_set.h.

## ◆ end() [2/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( |  | ) |
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multiset.

Definition at line 1447 of file unordered_set.h.

## ◆ end() [3/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) |
| inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1956 of file unordered_set.h.

## ◆ end() [4/4]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) | const
| inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1960 of file unordered_set.h.

## ◆ equal_range() [1/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::pair< iterator, iterator > std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) |
| inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1865 of file unordered_set.h.

## ◆ equal_range() [2/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::pair< const_iterator, const_iterator > std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) | const
| inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1877 of file unordered_set.h.

## ◆ erase() [1/5]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<__heterogeneous_hash_key< unordered_multiset > _Kt>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | _Kt && | __x | ) |
| inline

Definition at line 1677 of file unordered_set.h.

## ◆ erase() [2/5]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | const key_type & | __x | ) |
| inline

Erases elements according to the provided key.

Parameters

  __x | Key of element to be erased.

Returns
  The number of elements erased.

This function erases all the elements located by the given key from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1671 of file unordered_set.h.

## ◆ erase() [3/5]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inline

Erases a [__first,__last) range of elements from an unordered_multiset.

Parameters

  __first | Iterator pointing to the start of the range to be erased.
  __last | Iterator pointing to the end of the range to be erased.

Returns
  The iterator __last.

This function erases a sequence of elements from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1698 of file unordered_set.h.

## ◆ erase() [4/5]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __position | ) |
| inline

Erases an element from an unordered_multiset.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1648 of file unordered_set.h.

## ◆ erase() [5/5]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | iterator | __position | ) |
| inline

Erases an element from an unordered_multiset.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1653 of file unordered_set.h.

## ◆ find() [1/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) |
| inline

Tries to locate an element in an unordered_multiset.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1796 of file unordered_set.h.

## ◆ find() [2/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) | const
| inline

Tries to locate an element in an unordered_multiset.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1808 of file unordered_set.h.

## ◆ get_allocator()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

allocator_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::get_allocator | ( |  | ) | const
| inlinenoexcept

Returns the allocator object used by the unordered_multiset.

Definition at line 1405 of file unordered_set.h.

## ◆ hash_function()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

hasher std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::hash_function | ( |  | ) | const
| inline

Returns the hash functor object with which the unordered_multiset was constructed.

Definition at line 1772 of file unordered_set.h.

## ◆ insert() [1/6]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

A template function that inserts a range of elements.

Parameters

  __first | Iterator pointing to the start of the range to be inserted.
  __last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 1560 of file unordered_set.h.

## ◆ insert() [2/6]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const value_type & | __x | ) |
| inline

Inserts an element into the unordered_multiset.

Parameters

  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Insertion requires amortized constant time.

Definition at line 1516 of file unordered_set.h.

## ◆ insert() [3/6]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | const value_type & | __x )
| inline

Inserts an element into the unordered_multiset.

Parameters

  __hint | An iterator that serves as a hint as to where the element should be inserted.
  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant.

Definition at line 1542 of file unordered_set.h.

## ◆ insert() [4/6]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | value_type && | __x )
| inline

Inserts an element into the unordered_multiset.

Parameters

  __hint | An iterator that serves as a hint as to where the element should be inserted.
  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant.

Definition at line 1546 of file unordered_set.h.

## ◆ insert() [5/6]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | initializer_list< value_type > | __l | ) |
| inline

Inserts a list of elements into the unordered_multiset.

Parameters

  __l | A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 1571 of file unordered_set.h.

## ◆ insert() [6/6]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | value_type && | __x | ) |
| inline

Inserts an element into the unordered_multiset.

Parameters

  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Insertion requires amortized constant time.

Definition at line 1520 of file unordered_set.h.

## ◆ key_eq()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

key_equal std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_eq | ( |  | ) | const
| inline

Returns the key comparison object with which the unordered_multiset was constructed.

Definition at line 1778 of file unordered_set.h.

## ◆ load_factor()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

float std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::load_factor | ( |  | ) | const
| inlinenoexcept

Returns the average number of elements per bucket.

Definition at line 1972 of file unordered_set.h.

## ◆ max_bucket_count()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_bucket_count | ( |  | ) | const
| inlinenoexcept

Returns the maximum number of buckets of the unordered_multiset.

Definition at line 1898 of file unordered_set.h.

## ◆ max_load_factor() [1/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

float std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_load_factor | ( |  | ) | const
| inlinenoexcept

Returns a positive number that the unordered_multiset tries to keep the load factor less than or equal to.

Definition at line 1978 of file unordered_set.h.

## ◆ max_load_factor() [2/2]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_load_factor | ( | float | __z | ) |
| inline

Change the unordered_multiset maximum load factor.

Parameters

  __z | The new maximum load factor.

Definition at line 1986 of file unordered_set.h.

## ◆ max_size()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_size | ( |  | ) | const
| inlinenoexcept

Returns the maximum size of the unordered_multiset.

Definition at line 1422 of file unordered_set.h.

## ◆ operator=() [1/3]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

unordered_multiset & std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::operator= | ( | const unordered_multiset< _Value, _Hash, _Pred, _Alloc > & |  | ) |
| default

Copy assignment operator.

## ◆ operator=() [2/3]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

unordered_multiset & std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |
| inline

Unordered_multiset list assignment operator.

Parameters

  __l | An initializer_list.

This function fills an unordered_multiset with copies of the elements in the initializer list __l.

Note that the assignment completely changes the unordered_multiset and that the resulting unordered_multiset's size is the same as the number of elements assigned.

Definition at line 1397 of file unordered_set.h.

## ◆ operator=() [3/3]

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

unordered_multiset & std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::operator= | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > && |  | ) |
| default

Move assignment operator.

## ◆ rehash()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::rehash | ( | size_type | __n | ) |
| inline

May rehash the unordered_multiset.

Parameters

  __n | The new number of buckets.

Rehash will occur only if the new number of buckets respect the unordered_multiset maximum load factor.

Definition at line 1997 of file unordered_set.h.

## ◆ reserve()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::reserve | ( | size_type | __n | ) |
| inline

Prepare the unordered_multiset for a specified number of elements.

Parameters

  __n | Number of elements required.

Same as rehash(ceil(n / max_load_factor())).

Definition at line 2008 of file unordered_set.h.

## ◆ size()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::size | ( |  | ) | const
| inlinenoexcept

Returns the size of the unordered_multiset.

Definition at line 1417 of file unordered_set.h.

## ◆ swap()

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::swap | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > & | __x | ) |
| inlinenoexcept

Swaps data with another unordered_multiset.

Parameters

  __x | An unordered_multiset of the same element and allocator types.

This exchanges the elements between two sets in constant time. Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 1722 of file unordered_set.h.

The documentation for this class was generated from the following file:

- unordered_set.h